"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _alephbet_adapter = _interopRequireDefault(require("./alephbet_adapter"));

var _utils = _interopRequireDefault(require("../utils"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// # Adapter for using the gimel backend. See https://github.com/Alephbet/gimel
// # The main difference is the user_uuid generation (for backwards compatibility)
// # params:
// # - url: Gimel track URL to post events to
// # - namepsace: namespace for Gimel (allows setting different environments etc)
// # - storage (optional) - storage adapter for the queue
class GimelAdapter extends _alephbet_adapter.default {
  constructor(...args) {
    super(...args);

    _defineProperty(this, "queue_name", "_gimel_queue");
  }

  _user_uuid(experiment, goal) {
    if (!experiment.user_id) return _utils.default.uuid(); // if goal is not unique, we track it every time. return a new random uuid

    if (!goal.unique) return _utils.default.uuid(); // for a given user id, namespace and experiment, the uuid will always be the same
    // this avoids counting goals twice for the same user across different devices

    return _utils.default.sha1(`${this.namespace}.${experiment.name}.${experiment.user_id}`);
  }

}

var _default = GimelAdapter;
exports.default = _default;