"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _utils = _interopRequireDefault(require("../utils"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class GoogleUniversalAnalyticsAdapter {
  static _track(category, action, label) {
    _utils.default.log("Google Universal Analytics track", {
      category,
      action,
      label
    });

    if (typeof global.ga !== "function") {
      throw new Error("ga not defined. Please make sure " + "your Universal analytics is set up correctly");
    }

    global.ga("send", "event", category, action, label, {
      nonInteraction: 1
    });
  }

  static experiment_start(experiment, variant) {
    this._track(this.namespace, `${experiment.name} | ${variant}`, "Visitors");
  }

  static goal_complete(experiment, variant, goal_name, _props) {
    this._track(this.namespace, `${experiment.name} | ${variant}`, goal_name);
  }

}

_defineProperty(GoogleUniversalAnalyticsAdapter, "namespace", "alephbet");

var _default = GoogleUniversalAnalyticsAdapter;
exports.default = _default;