"use strict";

var _persistent_queue_keen_adapter = _interopRequireDefault(require("../src/adapters/persistent_queue_keen_adapter"));

var _utils = _interopRequireDefault(require("../src/utils"));

var _test_storage = _interopRequireDefault(require("./test_storage"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let keen;
let keen_client;
describe("PersistentQueueKeenAdapter", () => {
  beforeEach(() => {
    jest.spyOn(_utils.default, "uuid").mockImplementation(() => "uuid");
    const storage = new _test_storage.default();
    keen_client = {
      addEvent: jest.fn()
    };
    keen = new _persistent_queue_keen_adapter.default(keen_client, storage);
    jest.spyOn(keen, "_remove_quuid").mockImplementation(() => "callback");
  });
  it("starts an experiment", () => {
    expect.assertions(1);
    keen.experiment_start({
      name: "experiment"
    }, "blue");
    expect(keen_client.addEvent).toHaveBeenCalledWith("experiment", {
      uuid: "uuid",
      variant: "blue",
      event: "participate"
    }, "callback");
  });
});