"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _utils = _interopRequireDefault(require("./utils"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class Goal {
  constructor(name, props = {}) {
    this.name = name;
    this.props = props;

    _utils.default.defaults(this.props, {
      unique: true
    });

    this.experiments = [];
  }

  add_experiment(experiment) {
    this.experiments.push(experiment);
  }

  add_experiments(experiments) {
    for (const experiment of experiments) this.add_experiment(experiment);
  }

  complete() {
    for (const experiment of this.experiments) {
      experiment.goal_complete(this.name, this.props);
    }
  }

}

var _default = Goal;
exports.default = _default;